$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2015 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: alarm.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		アラーム通知機能のテンプレートファイル
$

$
$  AID_ALMの処理
$
$num_aalmid = 0$
$FOREACH i AALM.ORDER_LIST$
$	// noalmが負の場合（E_PAR）
	$IF AALM.NOALM[i] < 0$
		$ERROR AALM.TEXT_LINE[i]$E_PAR:$SPC$
			$FORMAT(_("illegal %1% `%2%\' in %3%"),
									"noalm", AALM.NOALM[i], "AID_ALM")$
		$END$
	$END$
	$num_aalmid = num_aalmid + AALM.NOALM[i]$
$END$
$num_almid = LENGTH(ALM.ID_LIST) + num_aalmid$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_ALMID	$num_almid$$NL$
$FOREACH id ALM.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Alarm Handler Functions$NL$
$SPC$*/$NL$
$NL$

$
$  アラーム通知のID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id ALM.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  静的に生成されたアラーム通知の数
$
#define TNUM_SALMID	$LENGTH(ALM.ID_LIST)$$NL$
$NL$

$
$  アラーム通知ID番号の最大値
$
const ID _kernel_tmax_almid = (TMIN_ALMID + TNUM_ALMID - 1);$NL$
const ID _kernel_tmax_salmid = (TMIN_ALMID + TNUM_SALMID - 1);$NL$
$NL$

$
$  アラーム通知初期化ブロック
$
$IF LENGTH(ALM.ID_LIST)$
	$FOREACH almid ALM.ID_LIST$
$		// almatrが無効の場合（E_RSATR）［NGKI2491］
$		//（TA_STA以外のビットがセットされている場合）
		$IF ALM.ALMATR[almid] != 0$
			$ERROR ALM.TEXT_LINE[almid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"almatr", ALM.ALMATR[almid], almid, "CRE_ALM")$
			$END$
		$END$

$		// 通知情報の処理
		$ALM.NFYHDR[almid] = GENERATE_NFYHDR(ALM.NFYMODE[almid],
								ALM.PAR1[almid], ALM.PAR2[almid],
								ALM.PAR3[almid], ALM.PAR4[almid],
								ALM.TEXT_LINE[almid], almid, "CRE_ALM")$
	$END$

$	// アラーム通知初期化ブロック
	const ALMINIB _kernel_alminib_table[TNUM_SALMID] = {$NL$
	$JOINEACH almid ALM.ID_LIST ",\n"$
		$TAB${$SPC$
			($ALM.ALMATR[almid]$),$SPC$
			(intptr_t)($ALM.PAR1[almid]$),$SPC$
			$ALM.NFYHDR[almid]$$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const ALMINIB, _kernel_alminib_table);$NL$
$END$$NL$

$
$  動的生成アラーム通知用のアラーム通知初期化ブロックと通知方法の格納
$  エリア
$
$IF num_aalmid > 0$
	ALMINIB _kernel_aalminib_table[$num_aalmid$];$NL$
	T_NFYINFO _kernel_aalm_nfyinfo_table[$num_aalmid$];$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(ALMINIB, _kernel_aalminib_table);$NL$
	TOPPERS_EMPTY_LABEL(T_NFYINFO, _kernel_aalm_nfyinfo_table);$NL$
$END$$NL$

$
$  アラーム通知管理ブロックとアラーム通知機能初期化関数
$
$IF num_almid > 0$
	ALMCB _kernel_almcb_table[TNUM_ALMID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_alarm();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(ALMCB, _kernel_almcb_table);$NL$
$END$$NL$
