$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: eventflag.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		イベントフラグ機能のテンプレートファイル
$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_FLGID	$LENGTH(FLG.ID_LIST)$$NL$
$FOREACH id FLG.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Eventflag Functions$NL$
$SPC$*/$NL$
$NL$

$
$  イベントフラグのID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id FLG.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  イベントフラグID番号の最大値
$
const ID _kernel_tmax_flgid = (TMIN_FLGID + TNUM_FLGID - 1);$NL$
$NL$

$
$  イベントフラグ初期化ブロック
$
$IF LENGTH(FLG.ID_LIST)$
	$FOREACH flgid FLG.ID_LIST$
$		// flgatrが無効の場合（E_RSATR）［NGKI1562］
$		//（TA_TPRI，TA_WMUL，TA_CLR以外のビットがセットされている場合）
		$IF (FLG.FLGATR[flgid] & ~(TA_TPRI|TA_WMUL|TA_CLR)) != 0$
			$ERROR FLG.TEXT_LINE[flgid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"flgatr", FLG.FLGATR[flgid], flgid, "CRE_FLG")$
			$END$
		$END$

$		// iflgptnがFLGPTNに格納できない場合（E_PAR）［NGKI3275］
		$IF (FLG.IFLGPTN[flgid] & ~((1 << TBIT_FLGPTN) - 1)) != 0$
			$ERROR FLG.TEXT_LINE[flgid]$E_PAR:$SPC$
				$FORMAT(_("too large %1% `%2%\' of `%3%\' in %4%"),
							"iflgptn", FLG.IFLGPTN[flgid], flgid, "CRE_FLG")$
			$END$
		$END$
	$END$

$	// イベントフラグ初期化ブロック
	const FLGINIB _kernel_flginib_table[TNUM_FLGID] = {$NL$
	$JOINEACH flgid FLG.ID_LIST ",\n"$
		$TAB${$SPC$
			($FLG.FLGATR[flgid]$),$SPC$
			($FLG.IFLGPTN[flgid]$)$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const FLGINIB, _kernel_flginib_table);$NL$
$END$$NL$

$
$  イベントフラグ管理ブロックとイベントフラグ機能初期化関数
$
$IF LENGTH(FLG.ID_LIST)$
	FLGCB _kernel_flgcb_table[TNUM_FLGID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_eventflag();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(FLGCB, _kernel_flgcb_table);$NL$
$END$$NL$
